All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
viennacl::implicit_matrix_base< NumericT > Class Template Reference

Base class for representing matrices where the individual entries are not all stored explicitly, e.g. identity_matrix<> More...

`#include <matrix_def.hpp>`

Inheritance diagram for viennacl::implicit_matrix_base< NumericT >:

## Public Types

typedef NumericT const & | const_reference
typedef NumericT | cpu_value_type

## Public Member Functions

size_type | size1 () const
size_type | size2 () const
viennacl::context | context () const
NumericT | value () const
bool | diag () const
const_reference | operator() (size_type i, size_type j) const

## Protected Types

typedef vcl_size_t | size_type

## Protected Member Functions

| implicit_matrix_base (size_type size1, size_type size2, NumericT value, bool diag, viennacl::context ctx)

## Protected Attributes

size_type | size1_
size_type | size2_
NumericT | value_
bool | diag_
NumericT | off_diag_
viennacl::context | ctx_

## Detailed Description

### template<typename NumericT>
class viennacl::implicit_matrix_base< NumericT >

Base class for representing matrices where the individual entries are not all stored explicitly, e.g. identity_matrix<>

Examples are identity_matrix, scalar_matrix, and zero_matrix.

Definition at line 35 of file matrix_def.hpp.

## Member Typedef Documentation

template<typename NumericT>

typedef NumericT const& viennacl::implicit_matrix_base< NumericT >::const_reference

Definition at line 41 of file matrix_def.hpp.

template<typename NumericT>

typedef NumericT viennacl::implicit_matrix_base< NumericT >::cpu_value_type

Definition at line 42 of file matrix_def.hpp.

template<typename NumericT>

typedef vcl_size_t viennacl::implicit_matrix_base< NumericT >::size_type

protected

Definition at line 38 of file matrix_def.hpp.

## Constructor & Destructor Documentation

template<typename NumericT>

viennacl::implicit_matrix_base< NumericT >::implicit_matrix_base | ( | size_type | size1,
|  | size_type | size2,
|  | NumericT | value,
|  | bool | diag,
|  | viennacl::context | ctx
| ) |  |

inline protected

Definition at line 39 of file matrix_def.hpp.

## Member Function Documentation

template<typename NumericT>

viennacl::context viennacl::implicit_matrix_base< NumericT >::context | ( |  | ) | const

inline

Definition at line 46 of file matrix_def.hpp.

template<typename NumericT>

bool viennacl::implicit_matrix_base< NumericT >::diag | ( |  | ) | const

inline

Definition at line 48 of file matrix_def.hpp.

template<typename NumericT>

const_reference viennacl::implicit_matrix_base< NumericT >::operator() | ( | size_type | i,
|  | size_type | j
| ) |  | const

inline

Definition at line 50 of file matrix_def.hpp.

template<typename NumericT>

size_type viennacl::implicit_matrix_base< NumericT >::size1 | ( |  | ) | const

inline

Definition at line 44 of file matrix_def.hpp.

template<typename NumericT>

size_type viennacl::implicit_matrix_base< NumericT >::size2 | ( |  | ) | const

inline

Definition at line 45 of file matrix_def.hpp.

template<typename NumericT>

NumericT viennacl::implicit_matrix_base< NumericT >::value | ( |  | ) | const

inline

Definition at line 47 of file matrix_def.hpp.

## Member Data Documentation

template<typename NumericT>

viennacl::context viennacl::implicit_matrix_base< NumericT >::ctx_

protected

Definition at line 61 of file matrix_def.hpp.

template<typename NumericT>

bool viennacl::implicit_matrix_base< NumericT >::diag_

protected

Definition at line 59 of file matrix_def.hpp.

template<typename NumericT>

NumericT viennacl::implicit_matrix_base< NumericT >::off_diag_

protected

Definition at line 60 of file matrix_def.hpp.

template<typename NumericT>

size_type viennacl::implicit_matrix_base< NumericT >::size1_

protected

Definition at line 56 of file matrix_def.hpp.

template<typename NumericT>

size_type viennacl::implicit_matrix_base< NumericT >::size2_

protected

Definition at line 57 of file matrix_def.hpp.

template<typename NumericT>

NumericT viennacl::implicit_matrix_base< NumericT >::value_

protected

Definition at line 58 of file matrix_def.hpp.

The documentation for this class was generated from the following file:

- viennacl/detail/matrix_def.hpp